<template>
<div>
  <v-row justify="center">
    <st-role-login
      v-for="role in roles" :key="role.id"
      :image="role.image"
      :text="role.text"
      :link="role.link"
      @changeRole="clicked(role)"
    />
  </v-row>

  <v-row justify="center" v-if="showUnits">
    <v-divider class="mx-4"></v-divider>
    <v-col md="12" class="text-center">
      <span class="body-2">Se encuentra como <b>coordinador</b> en <b>{{ units.length }} unidad(es)</b>.
        Seleccione para ingresar:</span>
    </v-col>
    <v-col md="12">
      <v-row justify="center">
        <v-card
          v-for="(unit,index) in units"
          :key="unit.id"
          class="mx-1 pa-6 text-center text-uppercase caption"
          max-width="150"
          elevation="1"
          hover
          @click="goUnit(index)"
        >
        {{ unit.tipo + ' de ' + unit.nombre }}
        </v-card>
      </v-row>
    </v-col>
  </v-row>
</div>
</template>

<script>
import RoleLogin from '@/components/RoleLogin'
export default {
  data () {
    return{
      showUnits: false,
    }
  },
  props:{
    roles:Array
  },
  components: {
    'st-role-login': RoleLogin
  },
  computed:{
    units(){
      return this.$store.state.roles.coordinador.units
    },
  },
  methods:{
    clicked(role){
      //no es la mejor manera pero rip
      if (role.units) {//es coordinador
        this.showUnits = !this.showUnits
      } else { //es otro rol
        let currentRole = {
          name: role.name, 
          id: role.id, 
          idUnit: role.idUnit, 
          options:role.options, 
          idRole: role.idRole 
        }
        //si es tutor se agrega este campo
        if(role.permission) currentRole.permission = role.permission 
        this.$store.commit('changeRole',currentRole)
        this.$router.push(role.link)
      }
    },
    goUnit(index){
      //aqui ya estan seteadas las unidades dentro de coordinador, solo queda armar la data
      let st = this.$store.state.roles.coordinador
      let unit = st.units[index]
      let optsProgram = st.options.slice(0,5) //los 5 primeros son para ambos tipos de coordinador
      let currentRole = {
        name: st.name + unit.nombre,
        id: st.id,
        idUnit: unit.idUnidad,
        options: unit.tipo == 'Facultad' ? st.options : optsProgram,
        idRole: st.idRole
      }
      this.$store.commit('changeRole', currentRole)
      this.$router.push(st.link)
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
.mx-4{
  max-width:800px;
}
</style>
